︠8146f4b8-adcd-4742-8beb-c07eb7f53bc4i︠
%html
<p><a href="https://groups.google.com/group/sage-devel/msg/e53caae140cef7df">Stein's trick</a></p>

︡627c6176-c13b-43a5-982f-6b20acfca13f︡{"html": "<p><a href=\"https://groups.google.com/group/sage-devel/msg/e53caae140cef7df\">Stein's trick</a></p>"}︡
︠e6fc4ddf-aa02-433c-972a-d1b75e6e096b︠
class integermodring:
    def __init__(self, modulus):
        self.modulus = modulus
    def eval(self, s, globals, locals):
        _temp = locals['Integer']
        locals['Integer'] = IntegerModRing(self.modulus)
        ans = python.eval(preparse(s),  globals, locals)
        locals['Integer'] = _temp
        return ans
︡843aeb8e-ebf5-4635-8344-95281a5c584c︡︡
︠5fce217f-efa5-4d12-9f33-bfce7a97b196︠
%integermodring(23)
42 - 9 * 6
︡ddc7cb97-a494-43d5-a63c-d2ec4e329d54︡{"stdout": "11"}︡
︠ce78fade-1ecd-491d-b838-b26743a88047︠
42 - 9 * 6
︡6297d135-336c-463e-907f-d9c90d442c59︡{"stdout": "-12"}︡
︠9d99430e-39fd-4f39-a10f-1d98674c5da4︠
class pyint:
    def eval(self, s, globals, locals):
        _temp = locals['Integer']
        locals['Integer'] = int
        ans = python.eval(preparse(s),  globals, locals)
        locals['Integer'] = _temp
        return ans
class myint:
    def eval(self, s, globals, locals):
        _temp = locals['Integer']
        locals['Integer'] = float
        ans = python.eval(preparse(s),  globals, locals)
        locals['Integer'] = _temp
        return ans
︡d01f6c9a-4ca4-42a3-9b10-87f7b7b8d2f4︡︡
︠37c0e70e-0029-4c85-b709-c0081889106b︠
%pyint()
print type(45)
print 500 / 1000, 1000 / 1000
print 500 / 1000., 1000 / 1000.
︡f9adc439-e5b8-4e3e-937d-5c0d5585cebf︡{"stdout": "<type 'int'>\n0 1\n0.500000000000000 1.00000000000000"}︡
︠bcee5795-65a9-49da-b1a0-2bb25114d152︠
%myint()
print type(45)
print 500 / 1000, 1000 / 1000
print 500 / 1000., 1000 / 1000.
︡1a0d2140-8683-464c-8693-4e79068a9904︡{"stdout": "<type 'float'>\n0.5 1.0\n0.500000000000000 1.00000000000000"}︡
︠e59fe8f8-59a3-4b41-a41d-592d895f707f︠
print type(45)
print 500 / 1000, 1000 / 1000
print 500 / 1000., 1000 / 1000.
︡37ea8f08-99f3-49d9-aed2-3feb114fd474︡{"stdout": "<type 'sage.rings.integer.Integer'>\n1/2 1\n0.500000000000000 1.00000000000000"}︡
︠82727654-1ac7-4f19-a522-de7eed40611c︠
import matplotlib.pyplot as plt
︡54c9b06a-ff14-4de8-a8ff-4ce51cb393d0︡︡
︠d520861c-e044-4cb3-a852-6133cdc139f6︠
%pyint()
plt.plot([1, 1/2, 1/3, 1/4], [1, 1/4, 1/9, 1/16], 'ro')
plt.axis([0, 1/2, 0, 2/5])
plt.savefig('pyint.png')
︡d3ce1d49-c03d-491c-bcfe-495501828a2e︡︡
︠d7267667-48b9-40f9-a35f-61d248a0ee6di︠
%html
<p>(0,0) ?</p>

︡a68e1a5c-e30a-4578-baab-ef795fff0794︡{"html": "<p>(0,0) ?</p>"}︡
︠a6ae3356-70f2-4fa0-b4a2-0dc50cd8d5d1︠
%myint()
plt.plot([1, 1/2, 1/3, 1/4], [1, 1/4, 1/9, 1/16], 'ro')
plt.axis([0, 1/2, 0, 2/5])
plt.savefig('myint.png')
︡79af77da-2794-4327-82d9-4593ccf552f4︡︡
︠57fe2c8e-6e51-40ac-90c1-332d7ab17cf4︠
plt.plot([1, 1/2, 1/3, 1/4], [1, 1/4, 1/9, 1/16], 'ro')
plt.axis([0, 1/2, 0, 2/5])
plt.savefig('integer.png')
︡dce3dcc7-093a-49b9-b59c-fb80c39dea7b︡{"stderr": "Traceback (most recent call last):\n  File \"<stdin>\", line 1, in <module>\n  File \"/home/sage/sagenb/sage_notebook/worksheets/qed777/19/code/18.py\", line 8, in <module>\n    plt.axis([_sage_const_0 , _sage_const_1 /_sage_const_2 , _sage_const_0 , _sage_const_2 /_sage_const_5 ])\n  File \"/home/sage/sage_install/sage-a/local/lib/python2.5/site-packages/matplotlib/pyplot.py\", line 827, in axis\n    v = ax.axis(*v, **kwargs)\n  File \"/home/sage/sage_install/sage-a/local/lib/python2.5/site-packages/matplotlib/axes.py\", line 1250, in axis\n    self.set_xlim([v[0], v[1]])\n  File \"/home/sage/sage_install/sage-a/local/lib/python2.5/site-packages/matplotlib/axes.py\", line 1944, in set_xlim\n    xmin, xmax = mtransforms.nonsingular(xmin, xmax, increasing=False)\n  File \"/home/sage/sage_install/sage-a/local/lib/python2.5/site-packages/matplotlib/transforms.py\", line 2237, in nonsingular\n    if (not np.isfinite(vmin)) or (not np.isfinite(vmax)):\nTypeError: function not supported for these types, and can't coerce safely to supported types"}︡
